Unit SFA1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure SFA1R(X :Real; Y :Real; RK :Real; EPS :Real; var REW :Real;
                var RIMW :Real; var N :Integer);

implementation

procedure SFA1R(X :Real; Y :Real; RK :Real; EPS :Real; var REW :Real;
                var RIMW :Real; var N :Integer);
var
R :Integer;
M,P,Q,A,B,C,D,EPS1,W :Real;
const
ONE :Real = 1.0;
ZERO :Real = 0.0;
label
_10,_20,_30;
begin
EPS1 := EPS*EPS;
REW := ONE;
C := ONE;
A := ONE;
N := 1;
W := RK-1;
RIMW := ZERO;
D := ZERO;
B := ZERO;
_10:
N := N+1;
R := N div 2;
if ( 2*R <> N ) 
 then goto _20;
M := R+W;
goto _30;
_20:
M := R;
_30:
P := X+M*C;
Q := Y+M*D;
M := P*P+Q*Q;
C := (X*P+Y*Q)/M;
D := (Y*P-X*Q)/M;
P := C-ONE;
Q := A;
A := A*P-B*D;
B := Q*D+P*B;
REW := REW+A;
RIMW := RIMW+B;
if ( (A*A+B*B)/(REW*REW+RIMW*RIMW) > EPS1 )
 then goto _10;
end;

end.
